/**
 * @name base.js<beez-mvcr>
 * @author Kei Funagayama <funagayama_kei@cyberagent.co.jp>
 * copyright (c) Cyberagent Inc.
 * @overview base class of managed object
 */

/* JSONPath 0.8.0 - XPath for JSON
         *
         * Copyright (c) 2007 Stefan Goessner (goessner.net)
         * Licensed under the MIT (MIT-LICENSE.txt) licence.
         *
         * @license https://github.com/s3u/JSONPath
         */

/**
 * @name base.js<beez-mvcr>
 * @author Kazuma MISHIMAGI <mishimagi_kazuma@cyberagent.co.jp">
 * copyright (c) Cyberagent Inc.
 * @overview base class of managed object
 */

!function(global){define("beez-mvcr/jsonpath",["require","exports","module","beez.core"],function(require,exports,module){var beez=require("beez.core"),_=beez.vendor._,cache={},jsonPath=function jsonPath(obj,expr,arg,testManaged){var P={resultType:arg&&arg.resultType||"VALUE",flatten:arg&&arg.flatten||!1,wrap:arg&&arg.hasOwnProperty("wrap")?arg.wrap:!0,normalize:function(e){if(cache[e])return cache[e];var t=[],n=e.replace(/[\['](\??\(.*?\))[\]']/g,function(e,n){return"[#"+(t.push(n)-1)+"]"}).replace(/'?\.'?|\['?/g,";").replace(/;;;|;;/g,";..;").replace(/;$|'?\]|'$/g,"").replace(/#([0-9]+)/g,function(e,n){return t[n]});return cache[e]=n,n},asPath:function(e){for(var t=e.split(";"),n="$",r=1,i=t.length;i>r;r++)n+=/^[0-9*]+$/.test(t[r])?"["+t[r]+"]":"['"+t[r]+"']";return n},store:function(e,t){return e&&("PATH"===P.resultType?P.result[P.result.length]=P.asPath(e):_.isArray(t)&&P.flatten?(P.result||(P.result=[]),_.isArray(P.result)||(P.result=[P.result]),P.result=P.result.concat(t)):P.result?(_.isArray(P.result)||(P.result=[P.result]),_.isArray(t)&&P.flatten?P.result=P.result.concat(t):P.result[P.result.length]=t):P.result=t),!!e},trace:function(e,t,n){if(e){var r=e.split(";"),i=r.shift();if(r=r.join(";"),t&&t.hasOwnProperty(i))P.trace(r,t[i],n+";"+i);else if("*"===i)P.walk(i,r,t,n,function(e,t,n,r,i){P.trace(e+";"+n,r,i)});else if(".."===i)P.trace(r,t,n),P.walk(i,r,t,n,function(e,t,n,r,i){"object"==typeof r[e]&&P.trace("..;"+n,r[e],i+";"+e)});else if(/,/.test(i))for(var o=i.split(/'?,'?/),s=0,a=o.length;a>s;s++)P.trace(o[s]+";"+r,t,n);else/^\(.*?\)$/.test(i)?P.trace(P.evaluate(i,t,n.substr(n.lastIndexOf(";")+1))+";"+r,t,n):/^\?\(.*?\)$/.test(i)?P.walk(i,r,t,n,function(e,t,n,r,i){P.evaluate(t.replace(/^\?\((.*?)\)$/,"$1"),r[e],e)&&P.trace(e+";"+n,r,i)}):/^(-?[0-9]*):(-?[0-9]*):?([0-9]*)$/.test(i)&&P.slice(i,r,t,n)}else t&&(_.isArray(t)||testManaged(t))&&P.store(n,t)},walk:function(e,t,n,r,i){if(n instanceof Array)for(var o=0,s=n.length;s>o;o++)o in n&&i(o,e,t,n,r);else if("object"==typeof n&&testManaged(n))for(var a in n)n.hasOwnProperty(a)&&i(a,e,t,n,r)},slice:function(e,t,n,r){if(n instanceof Array){var i=n.length,o=0,s=i,a=1;e.replace(/^(-?[0-9]*):(-?[0-9]*):?(-?[0-9]*)$/g,function(e,t,n,r){o=parseInt(t||o,10),s=parseInt(n||s,10),a=parseInt(r||a,10)}),o=0>o?Math.max(0,o+i):Math.min(i,o),s=0>s?Math.max(0,s+i):Math.min(i,s);for(var c=o;s>c;c+=a)P.trace(c+";"+t,n,r)}},evaluate:function(x,_v,_vname){try{return $&&_v&&eval(x)}catch(e){throw new SyntaxError("jsonPath: "+e.message+": "+x.replace(/\^/g,"_a"))}}};P.result=P.wrap===!0?[]:void 0;var $=obj;return expr&&obj&&("VALUE"===P.resultType||"PATH"===P.resultType)?(P.trace(P.normalize(expr).replace(/^\$;/,""),obj,"$"),!_.isArray(P.result)&&P.wrap&&(P.result=[P.result]),P.result?P.result:!1):void 0};return jsonPath})}(this),function(){define("beez-mvcr/base",["require","exports","module","beez.core","beez-mvcr/jsonpath"],function(e){var t=e("beez.core"),n=t.vendor._,r=e("beez-mvcr/jsonpath"),i=t.getLogger("beez.mvcr.base"),o=t.extend("beez.manager.ManagerBase",function(){},{constructor:function(e){this.objs={},this.objs[e]="$",this._idxProp=e||"",this.initialize.apply(this,arguments)},initialize:function(){},getIdx:function(e){return e[this._idxProp]},add:function(e,r){var i=this.get(e);if(!i)throw new t.Error("no parent exists. path: "+e);if(n.isArray(i))throw new t.Error("parent is Array. Specify one by using `[number]` selector. parent: "+i);if(n.isArray(r))n.each(r,function(t){t.prefix=e;var n=this.getIdx(t);i[n]||(i[n]=[]),i[n].push(t)},this);else{r.prefix=e;var o=this.getIdx(r);if(i[o])throw new t.Error("Obj: adding object to same parent with same index. Add obj as Array to add several objs into same index. idx: "+this.getIdx(r));i[o]=r}return this},remove:function(e){var t,r=this.get(e),i=[];r&&(n.isArray(r)||(r=[r]),n.each(r,function(e){var t=this.getChildrenAll(e);i=i.concat(t)},this),t=i.concat(r),n.each(t,function(e){this.deleteFromParent(e)},this),n.each(t,function(e){e.dispose&&e.dispose()}))},isAddable:function(e){return!!this.getIdx(e)},get:function(e){if(void 0===e||"string"!=typeof e)return void 0;if(/^\/$/.test(e))return this.objs;var t=this;e="$"+e.replace(/\//g,".");var n=r(this.objs,e,{wrap:!1},function(e){return t.isAddable(e)});return n?n:void 0},getParent:function(e){return n.isArray(e)?this.get(e[0].prefix):this.get(e.prefix)},deleteFromParent:function(e){if(e){var t=this.getParent(e);n.isArray(e)?delete t[this.getIdx(e[0])]:delete t[this.getIdx(e)]}},getChildren:function(e){var t=[],r=this,i=function o(e){n.each(e,function(e){e&&(n.isArray(e)?o(e):r.getIdx(e)&&t.push(e))})};return i(e),t},getChildrenAll:function(e){var t=[],r=this,o=function s(e){var o=e;n.isArray(e)||(o=n.values(e)),n.each(o,function(o){if(o)if(n.isArray(o))s(o);else if(r.getIdx(o)){if(!o.prefix||!o.manager)return i.warn("Manager ignore the Object haven't been manaegd.",o),void 0;if("$"!==e[r._idxProp]&&!n.isArray(e)&&o.getParent()[r._idxProp]!==e[r._idxProp])return i.warn("Manager ignore the Object haven't been manaegd.","Path that is managed:",r.pathOf(o),"Path to the specified:",r.pathOf(e)),void 0;s(o),t.push(o)}})};return o(e),t},pathOf:function(e){var r="";if(n.isArray(e)){if(n.isEmpty(e))throw new t.Error("pathOf: obj is empty array.");e=e[0]}if(r=e.prefix,!r)throw new t.Error("pathOf: object.prefix does not exist.");return r+(/^\/$/.test(r)?"":"/")+this.getIdx(e)},trace:function(){var e={},t=this.getChildrenAll(this.objs||{}),r=this;return n.each(t,function(t){if(t){var i;i="/"===t.prefix?t.prefix+r.getIdx(t):t.prefix+"/"+r.getIdx(t),e[i]?(n.isArray(e[i])||(e[i]=[e[i]]),e[i].push(t)):e[i]=t}}),e},dispose:function(){delete this.objs,delete this._idxProp}}),s=t.extend("beez.mvcr.Base",function(){},{getParent:function(){return this.manager.getParent(this)},deleteFromParent:function(){return this.manager.deleteFromParent(this)},getChildren:function(){return this.manager.getChildren(this)},getChildrenAll:function(){return this.manager.getChildrenAll(this)},alias:function(e){return this.manager.add(e,this)}});return{ManagerBase:o,Base:s}})}(this),function(){define("beez-mvcr/model",["require","exports","module","beez.core","backbone","beez-mvcr/base"],function(e){var t=e("beez.core"),n=t.vendor._,r=e("backbone"),i=t.vendor.$,o=e("beez-mvcr/base"),s=o.Base,a=o.ManagerBase,c=t.getLogger("beez.mvcr.model"),u=t.Bucks.extend("beez.mvcr.ModelManagerAsync",{initialize:function(e){this.manager=e,this.current=void 0,this.root=void 0},create:function(e,n,r,i){var o=this;return this.then(function(){var s=o.manager.create(e,n,r,i);return o.root=o.current=s,o.create=function(){throw new t.Error("create called more than once!")},s})},createCollection:function(e,n,r,i){var o=this;return this.then(function(){var s=o.manager.createCollection(e,n,r,i);return o.root=o.current=s,o.createCollection=function(){throw new t.Error("create called more than once!")},s})},child:function(e,r,i){var o=this;return this.then(function(){if(!o.root)throw new t.Error("No chain root exists. `create` first.");var s=o.manager.pathOf(o.current),a=o.manager.create(s,e,r,i);o.current=n.isArray(a)?a[0]:a})},parent:function(){var e=this;return this.then(function(){if(e.current=e.manager.getParent(e.current),!e.current)throw new t.Error("get parent failed")})},bro:function(e,t,n){return this.parent().child(e,t,n)},dispose:function(){c.trace(this.constructor.name,"dispose"),delete this.manager,delete this.current,this.root&&this.root.dispose&&this.root.dispose(),delete this.root}}),l=t.extend("beez.mvcr.ModelManager",a,{initialize:function(){var e=this;l.__super__.initialize.apply(this,arguments),this._sync=t.vendor.Backbone.sync,t.vendor.Backbone.sync=function(r,i,o){var s=t.config.ajax||{};n.defaults(o||(o={}),s,{dataType:"json",contentType:"application/json",emulateHTTP:!1,emulateJSON:!1}),e._sync.apply(this,arguments)}},async:function(){return new u(this)},root:function m(e){var n=new e(this),m=this.get("/@");if(m)throw new t.Error("root already exists!");if("@"!==n.midx)throw new t.Error('roots midx must be "@"');return this.add("/",n),n},create:function(e,r,i,o){if(!r||!n.isArray(r)&&"function"!=typeof r){var s="Model does not exist / does not be funciton. Specified prefix: "+e;throw new t.Error(s)}if(r instanceof g)throw new t.Error("Collection specified.  Use #createCollection instead.");if(!e)throw new t.Error("No prefix specified. Creating:"+r.name);if(e.indexOf("/@")<0)throw new t.Error('prefix must started by "/@". Creating:'+r.name);if(!this.get(e))throw new t.Error("no parent exists. prefix: "+e+" ,  Please consider constructing in Controller and so on.");return n.isArray(r)?this._createArray(e,r,i,o):this._createObj(e,r,i,o)},_createObj:function(e,n,r,i){var o=new n(r,i,this);if(!this.isAddable(o))throw new t.Error("index does not exists in the Model. :"+o);return this.add(e,o),o},_createArray:function(e,r,i,o){i&&!n.isArray(i)&&(i=[i]),o&&!n.isArray(o)&&(o=[o]);var s=this,a=[];return n.each(r,function(e,t){var n=i?i[t]:void 0,r=o?o[t]:void 0;a.push(new e(n,r,s))}),n.each(a,function(e){if(!this.isAddable(e))throw new t.Error("index does not exist in the Model. :"+e)},this),this.add(e,a),a},createCollection:function(e,n,r,i){if(!n||"function"!=typeof n){var o="Collection does not exist / does not be funciton. Specified prefix: "+e;throw new t.Error(o)}if(!e)throw new t.Error("No prefix specified. Creating:"+n.name);if(e.indexOf("/@")<0)throw new t.Error('prefix must started by "/@". Creating:'+n.name);var s=new n(r,i,this);return this.add(e,s),s},_newAll:function(e,r,i){if(!e)throw new t.Error("ctor does not exist.");n.isArray(e)||(e=[e]),r&&!n.isArray(r)&&(r=[r]),i&&!n.isArray(i)&&(i=[i]);var o=[];return n.each(e,function(e,t){var n=r?r[t]:void 0,s=i?i[t]:void 0;o.push(new e(n,s))}),o},_decideBindedModel:function(e,r){var i,o,s;if(r)o=e;else{i=e,s=[],n.each(i,function(e){var t=this.getChildrenAll(e);s=s.concat(t)},this);var a=s.concat(i),c=n.reject(a,function(e){return e.isBinded()}),u=n.difference(a,c);n.each(u,function(e){throw new t.Error("a disposing model have some bindings. models cid: "+e.cid)}),o=c}return o},remove:function(e,t){var r=this.get(e);if(!r)return c.debug("Path of unmanaged become subject to deletion, I was skipped. path:",e),this;if(c.debug(this.constructor.name,"remove. path:",e),r.isCollection())return this._decideBindedModel(r,!0).removeAll&&this._decideBindedModel(r,!0).removeAll(t),this.deleteFromParent(r),this;r&&!n.isArray(r)&&(r=[r]);var i=this._decideBindedModel(r);return n.each(i,function(e){this.deleteFromParent(e)},this),n.each(i,function(e){e.dispose&&e.dispose()}),this},ajax:function(e){var r=e.type,o=t.config.ajax||{},s=t.config.url&&t.config.url.api;if(n.defaults(e||(e={}),o,{dataType:"json",contentType:"application/json",emulateHTTP:!1,emulateJSON:!1,urlRoot:s||""}),/^(http|https):\/\//.test(e.url)||(e.url=e.urlRoot+e.url),e.data&&e.contentType&&0===e.contentType.indexOf("application/json")&&n.isObject(e.data)&&(e.data=JSON.stringify(e.data)),e.emulateJSON&&(e.contentType="application/x-www-form-urlencoded"),"GET"===e.type||e.emulateJSON||(e.processData=!1),e.emulateHTTP&&("PUT"===r||"DELETE"===r||"PATCH"===r)){e.type="POST",e.emulateJSON&&(e.data._method=r);var a=e.beforeSend;e.beforeSend=function(t,n){!e.emulateHTTP||"PUT"!==r&&"DELETE"!==r&&"PATCH"!==r||(n.headers?n.headers["X-HTTP-Method-Override"]=r:t.setRequestHeader("X-HTTP-Method-Override",r)),a&&a.apply(null,arguments)}}return i.ajax.call(null,e)},$get:function(e){return n.extend(e||(e={}),{type:"GET"}),this.ajax(e)},$post:function(e){return n.extend(e||(e={}),{type:"POST"}),this.ajax(e)},$put:function(e){return n.extend(e||(e={}),{type:"PUT"}),this.ajax(e)},$delete:function(e){return n.extend(e||(e={}),{type:"DELETE"}),this.ajax(e)},$patch:function(e){return n.extend(e||(e={}),{type:"PATCH"}),this.ajax(e)},dispose:function(){c.trace(this.constructor.name,"dispose");var e=this.getChildrenAll(this.objs);n.each(e,function(e){e.dispose()}),delete this.urlRoot,delete this._sync,l.__super__.dispose.apply(this,arguments)}}),h=t.Bucks.extend("beez.mvcr.ModelAsync",{initialize:function(e){this.model=e},fetch:function(e){var t=this.model;return this.then(function(r,i){e=e?n.clone(e):{},e.success=function(e,t){i(null,{model:e,res:t})},e.error=function(t,n){i(new Error(JSON.stringify({model:t,res:n,options:e})))},t.fetch(e)})},save:function(e,t,r){var i;null==e||n.isObject(e)?(i=e,r=t):null!=e&&((i={})[e]=t);var o=this.model;return this.then(function(e,t){r=r?n.clone(r):{},r.success=function(e,n){t(null,{model:e,res:n})},r.error=function(e,n){t(new Error(JSON.stringify({model:e,res:n,options:r})))},o.save(i,r)})},destroy:function(e){var t=this.model;return this.then(function(r,i){e=e?n.clone(e):{},e.success=function(e,t){i(null,{model:e,res:t})},e.error=function(t,n){i(new Error(JSON.stringify({model:t,res:n,options:e})))},t.destroy(e)})},dispose:function(){c.trace(this.constructor.name,"dispose"),delete this.model}}),d=t.extend("beez.mvcr.Model",s,r.Model.prototype,{constructor:function(e,r){var i=Array.prototype.slice.call(arguments);r=r||{};var o="";r.urlRoot?o=r.urlRoot:t.config&&t.config.url&&(o=t.config.url.api||""),r.urlRoot=o,n.extend(this,n.pick(r,["urlRoot"])),(1===i.length&&i[0].objs||2===i.length&&i[1].objs||3===i.length&&i[2].objs)&&(this.manager=i[i.length-1]),this.manager||c.debug("Manager can't be managed this model."),d.__super__.constructor.call(this,e,r)},initialize:function(){d.__super__.initialize.apply(this,arguments)},midx:void 0,async:function(){return new h(this)},isCollection:function(){return!1},isModel:function(){return!0},isBinded:function(){if(this._events){var e,t=this;return n.some(this._events,function(r){return e=n.reject(r,function(e){return e.context===t}),e.length>0})}return!1},dispose:function(){c.trace(this.constructor.name,"dispose"),delete this.manager,delete this.cid,delete this.attributes,delete this.collection},remove:function(){throw new t.Error("Use Backbone.model.destroy() or Model.dipose() instead of this")}});d.extend=t.extendThis;var f=t.Bucks.extend("beez.mvcr.CollectionAsync",{initialize:function(e){this.collection=e},create:function(e,t){var n=this;return this.then(function(){return n.collection.create(e,t)})},remove:function(e,t){var n=this;return this.then(function(){return n.collection.remove(e,t)})},_reset:function(){var e=this;return this.then(function(){return e.collection._reset()})},dispose:function(){c.trace(this.constructor.name,"dispose"),delete this.collection}}),g=t.extend(s,r.Collection.prototype,{constructor:function(e,n,r){this.model||(this.model=d),this.urlRoot=function(){var e="";return t.config&&t.config.url&&(e=t.config.url.api||""),e}(),this.manager=r;var i=arguments;3<=arguments.length&&(i=Array.prototype.slice.call(arguments,0,arguments.length-1)),g.__super__.constructor.apply(this,i)},initialize:function(){g.__super__.initialize.apply(this,arguments)},midx:void 0,async:function(){return new f(this)},isCollection:function(){return!0},isModel:function(){return!1},remove:function(e){return g.__super__.remove.apply(this,arguments),e=n.isArray(e)?e.slice():[e],n.each(e,function(e){e.dispose&&e.dispose()}),this},removeAll:function(e){return this.remove(this.models,e)},_reset:function(){this.length=0,n.each(this.models,function(e){e.dispose&&e.dispose()}),this.models=[],this._byId={}},isBinded:function(){if(this._events){var e,t=this;return n.some(this._events,function(r){return e=n.reject(r,function(e){return e.context===t}),e.length>0})}return!1},dispose:function(){c.trace(this.constructor.name,"dispose"),n.each(this.models,function(e){e.dispose&&e.dispose()}),delete this.manager,delete this.comparator,delete this.length,delete this.models,delete this._byId}});return g.extend=t.extendThis,{Model:d,Collection:g,ModelManager:l,ModelManagerAsync:u}})}(this),function(){define("beez-mvcr/modic",["require","exports","module","beez.core","backbone","beez-mvcr/model"],function(e){var t=e("beez.core"),n=(t.vendor._,e("backbone"),e("beez-mvcr/model")),r=n.Model.extend("beez.mvcr.Modic",{midx:void 0,lRoot:function(){throw new t.Error("not allowed to use this function.")},url:function(){throw new t.Error("not allowed to use this function.")},async:function(){throw new t.Error("not allowed to use this function.")},fetch:function(){throw new t.Error("not allowed to use this function.")},save:function(){throw new t.Error("not allowed to use this function.")}});return{Modic:r}})}(this),function(){define("beez-mvcr/view",["require","exports","module","beez.core","beez.utils","backbone","beez-mvcr/base"],function(e){var t=e("beez.core");e("beez.utils");var n=t.vendor._,r=e("backbone"),i=e("beez-mvcr/base"),o=i.Base,s=i.ManagerBase,a=t.getLogger("beez.mvcr.view"),c=t.Bucks.extend("beez.mvcr.ViewManagerAsync",{initialize:function(e){this.manager=e},root:function d(d){var e=this;return this.then(function(){return e.manager.root(d)})},create:function(e,t,r){var i=this;return this.then(function(){var o=i.manager.create(e,t,r),s=n.isArray(o)?o[0]:o;return s})},child:function(e,t){var r=this;return this.then(function(i){var o=r.manager.pathOf(i),s=r.manager.create(o,e,t);return i=n.isArray(s)?s[0]:s})},parent:function(){var e=this;return this.then(function(n){var r=e.manager.getParent(n);if(r)throw new t.Error("get parent failed. current: "+n);return n=r})},bro:function(e,t){return this.parent().child(e,t)},dispose:function(){a.trace(this.constructor.name,"dispose"),delete this.manager,delete this.current,delete this.root}}),u=t.extend("beez.mvcr.ViewManager",s,{initialize:function(){u.__super__.initialize.apply(this,arguments)},async:function(){return new c(this)},root:function f(e){this.add("/",new function(){this.vidx="@"});var n=new e(this),r=this.getChildren(this.get("/@"));this.remove("/@");var f=this.get("/@");if(f)throw new t.Error("root already exists!");if("@"!==n.vidx)throw new t.Error('roots vidx must be "@"');this.add("/",n);for(var i=0;i<r.length;i++)this.add("/@",r[i]);return n},create:function(e,r,i){if(!r||!n.isArray(r)&&"function"!=typeof r)throw new t.Error("View does not exist / does not be funciton. Specified prefix: "+e);if(!e)throw new t.Error("No prefix specified. Creating:"+r.name);if(e.indexOf("/@")<0)throw new t.Error('prefix must started by "/@". Creating:'+r.name);if(!this.get(e))throw new t.Error("no parent exists. prefix: "+e+" ,  Please consider constructing view in Controller, or in #beforeOnce and so on.");return n.isArray(r)?this._createArray(e,r,i):this._createObj(e,r,i)},_createObj:function(e,n,r){var i=new n(this,r);if(!this.isAddable(i))throw new t.Error("index does not exists in the View. :"+i);return this.add(e,i),i},_createArray:function(e,r,i){var o=this;i&&!n.isArray(i)&&(i=[i]);var s=[];return n.each(r,function(e,t){var n=i?i[t]:void 0,r=new e(o,n);s.push(r)}),n.each(s,function(e){if(!this.isAddable(e))throw new t.Error("index does not exists in the View. :"+e)},this),this.add(e,s),s},remove:function(){u.__super__.remove.apply(this,arguments)},dispose:function(){a.trace(this.constructor.name,"dispose");var e=this.getChildrenAll(this.objs);n.each(e,function(e){e.dispose()}),u.__super__.dispose.apply(this,arguments)}}),l=t.Bucks.extend("beez.mvcr.ViewAsync",{initialize:function(e){this._root=e},_render:function(e){return this.then(function(){return e}),e.state.isBeforeOnce||this.then(function(e,t){return e.visible?e.beforeOnce.length>0?(e.beforeOnce(function(){e.state.isBeforeOnce=!0,t(null,e)}),void 0):(e.beforeOnce(),e.state.isBeforeOnce=!0,t(null,e),void 0):(a.debug("view",e.vidx,"is not visible. skip `beforeOnce`."),t(null,e),void 0)}),this.then(function(e,t){return e.visible?e.before.length>0?(e.before(function(){t(null,e)}),void 0):(e.before(),t(null,e),void 0):(a.debug("view",e.vidx,"is not visible. skip `before`."),t(null,e),void 0)}),this.then(function(e,t){return e.visible?e.render.length>0?(e.render(function(){t(null,e)}),void 0):(e.render(),t(null,e),void 0):(a.debug("view",e.vidx,"is not visible. skip `render`."),t(null,e),void 0)}),this.then(function(e,t){return e.visible?e.after.length>0?(e.after(function(){t(null,e)}),void 0):(e.after(),t(null,e),void 0):(a.debug("view",e.vidx,"is not visible. skip `after`."),t(null,e),void 0)}),e.state.isAfterOnce||this.then(function(e,t){return e.visible?e.afterOnce.length>0?(e.afterOnce(function(){e.state.isAfterOnce=!0,t(null,e)}),void 0):(e.afterOnce(),e.state.isAfterOnce=!0,t(null,e),void 0):(a.debug("view",e.vidx,"is not visible. skip `afterOnce`."),t(null,e),void 0)}),this.then(function(e,t){return e.visible?(a.debug("view",e.vidx,"is rendered. trigger beez:view:render"),e.trigger("beez:view:render"),t(null,e),void 0):(a.debug("view",e.vidx,"is not visible. skip trigger events beez:view:render"),t(null,e),void 0)}),this},_remove:function(e){return this.then(function(){return e}),this.then(function(e,t){return e.conceal.length>0?(e.conceal(function(){t(null,e)}),void 0):(e.conceal(),t(null,e),void 0)}),this.then(function(e,t){e.remove(),a.debug("view",e.vidx,"is removed. trigger beez:view:remove"),e.trigger("beez:view:remove"),t(null,e)}),this},show:function(e){if(!this._root)throw new t.Error("render root is not set. initialize renderer with root view parameter.");return e=e||{},t.utils.isBoolean(e)&&(e={showChildren:e}),void 0===e.showChildren&&(e.showChildren=!0),this._show(this._root,e)},_show:function(e,t){a.debug("showing",e.vidx);var r=this,i=e.getChildren();return t.filter&&(a.debug("filtering",e.vidx),i=n.filter(i,t.filter)),this._render(e),i.length>0&&t.showChildren&&(i.sort(function(e,t){return e.order<t.order?-1:e.order>t.order?1:0}),n.each(i,function(e){r._show(e,t)})),this},hide:function(e){if(!this._root)throw new t.Error("render root is not set. initialize renderer with root view parameter.");return e=e||{},t.utils.isBoolean(e)&&(e={hideChildren:e}),void 0===e.hideChildren&&(e.hideChildren=!0),this._hide(this._root,e)},_hide:function(e,t){a.debug("hiding",e.vidx);var r=this,i=e.getChildren();return t.filter&&(a.debug("filtering",e.vidx),i=n.filter(i,t.filter)),i.length>0&&t.hideChildren&&(i.sort(function(e,t){return e.order<t.order?1:e.order>t.order?-1:0}),n.each(i,function(e){r._hide(e,t)})),a.debug("hiding",e.vidx),this._remove(e),this},dispose:function(){a.trace(this.constructor.name,"dispose"),delete this._root}}),h=t.extend("beez.mvcr.View",o,r.View.prototype,{constructor:function(){if(arguments.length<1)throw new t.Error("In order to create a View, requires one arguments.");this.manager=arguments[0],this.state={isBeforeOnce:!1,isAfterOnce:!1},this.visible=!0,h.__super__.constructor.apply(this,Array.prototype.slice.call(arguments,1))},initialize:function(){h.__super__.initialize.apply(this,arguments)},vidx:void 0,el:void 0,order:0,beforeOnce:t.none,before:t.none,after:t.none,afterOnce:t.none,async:function(){return new l(this)},isRendered:function(){return!!this.el&&!!this.el.parentElement},setVisible:function(e){if("boolean"!=typeof e)throw t.Error("typeof visible invalid. should be boolean.");return this.visible=e,this},dispose:function(){a.trace(this.constructor.name,"dispose"),this.remove(),h.__super__.undelegateEvents.apply(this,arguments),delete this.manager,delete this.state,delete this.visible,delete this.cid,delete this.options,delete this.$el,delete this.model,delete this.collection,delete this.el,delete this.attributes,delete this.className,delete this.tagName},conceal:t.none,remove:function(){h.__super__.remove.apply(this,arguments)}});return h.extend=t.extendThis,{View:h,ViewAsync:l,ViewManager:u,ViewManagerAsync:c}})}(this),function(){define("beez-mvcr/controller",["require","exports","module","beez.core","beez.mvcr","beez.i18n"],function(e){var t=e("beez.core");e("beez.mvcr"),e("beez.i18n");var n=t.getLogger("beez.mvcr.controller"),r=t.vendor._,i=t.Bucks.extend("beez.mvcr.ControllerManagerAsync",{initialize:function(e){this.manager=e},create:function(e,r){var i=this;return this.then(function(n,o){if(!r||"function"!=typeof r)throw new t.Error("Controller does not exist / does not be funciton. Specified name: "+e);if(i.manager.controllers[e])throw new t.Error("It is a singleton in the module. name:"+e);var s=new r;i.manager.controllers[e]=s,o(n,i.manager.controllers[e])}).then(function(e,t){e.loadCSS(function(){t(null,e)})}).then(function(e,t){e.loadI18n(function(r){r&&(n.error("i18n load error. ",r.message),n.debug(r.stack)),t(r,e)})})},dispose:function(){n.trace(this.constructor.name,"dispose"),delete this.manager}}),o=t.extend("beez.mvcr.ControllerManager",function(){return this.initialize()},{initialize:function(){this.controllers={}},async:function(){return new i(this)},remove:function(e){var t=this.get(e);return t?(delete this.controllers[e],this):this},get:function(e){return this.controllers[e]},dispose:function(){n.trace(this.constructor.name,"dispose"),delete this.controllers}}),s=t.extend("beez.mvcr.Controller",function(){this.initialize.apply(this,arguments)},{constructor:function(){this.state={isBeforeOnce:!1,isAfterOnce:!1},s.__super__.constructor.apply(this,arguments)},initialize:function(){},i18n:function(){},loadI18n:function(i){t.i18n||t.createI18n();var o=this;if(t.utils.is("Object",this.i18n)){var s=[],a=[];r.each(this.i18n,function(e,t){s.push(t),a.push(e)}),e(a,function(){for(var e=Array.prototype.slice.call(arguments),r=0;r<e.length;r++){var o={};o[s[r]]=e[r],t.i18n.add(o),n.debug("i18n file loaded. path:",a[r])}i&&i(null)},function(e){i&&i(e)})}else t.utils.is("Function",this.i18n)?(new t.Bucks).add(function(e,t,n){0<o.i18n.length?o.i18n(function(e,t){n(e,t)}):n(null,o.i18n())}).add(function(e,n){n&&t.i18n.add(n),i&&i(e,n)}).end():i&&i(new Error("The Controller.i18n, please be defined in Function."));return this},beforeOnce:t.none,before:t.none,after:t.none,afterOnce:t.none,loadCSS:function(e){var n=this.css;if(!n||n.length<1)return e&&e();var i=r.map(n,function(e){return function(n,r,i){t.manager.css.async().load(e).end(function(e,t){i(n,t[0])},function(e){i(e)})}}),o=new t.Bucks;return o.parallel(i).end(function(t,n){e&&e(t,n)}),this},show:function(e,n,i){var o=this,s=new t.Bucks,a=t.utils.isFunction(i),c=function(e,t,n){var i=o[e],s=i.length,c=r.clone(t);s&&a?(c[s-1]=n,i.apply(o,c)):(i.apply(o,c),n())};this.state.isBeforeOnce||s.then(function(e,t){c("beforeOnce",n,function(){o.state.isBeforeOnce=!0,t(null,o)})}),s.then(function(e,t){c("before",n,function(){t(null,o)})}),s.then(function(t,r){c(e,n,function(){r(null,o)})}),s.then(function(e,t){c("after",n,function(){t(null,o)})}),this.state.isAfterOnce||s.then(function(e,t){c("afterOnce",n,function(){o.state.isAfterOnce=!0,t(null,o)})}),s.end(function(e,t){if(i)i(e,t);else if(e)throw e})},dispose:function(){n.trace(this.constructor.name,"dispose"),delete this.constructor.prototype.css}});return s.extend=t.extendThis,{Controller:s,ControllerManager:o,ControllerManagerAsync:i}})}(this),function(){define("beez-mvcr/router",["require","exports","module","beez.core","beez.mvcr","backbone"],function(e){var t=e("beez.core");e("beez.mvcr");var n=t.getLogger("beez.mvcr.router"),r=t.vendor._,i=e("backbone"),o={initialize:function(){this.router=void 0,this.setuped=!1},setup:function(i,o){var s=this;if(this.setuped)throw new t.Error("Already been executed once. If you want to add a route, please refer to the function add().");var a=t.config.router||{},c=r.extend(a,i);if(this.router)return this;this.router=o||new t.Router;for(var u=r.keys(c),l=0;l<u.length;l++){var h=u[l],d=c[h];this.router.route(d.route,d.name,function(r){function i(){if(!c.hasOwnProperty(r))throw new t.Error("route map key does not exist. name: "+r);var i=c[r],o=Array.prototype.slice.call(arguments),a=new t.Bucks,u=!!t.manager.c.get(i.xpath),l=i.async;n.debug("router.proxy",i),u||a.then(function(e,r){if(l){if(2!==s.router.firstBefore.length)throw new t.Error("You should pass a callback function in arguments in case of async setting is true. firestBefore(data, callback)");n.trace("run controller firstBefore function(async). data:",i),s.router.firstBefore(i,function(e,t){r(null,t)})}else n.trace("run controller firstBefore function(sync). data:",i),s.router.firstBefore(i),r(null,e)}),a.then(function(n,r){e([i.require],function(e){var n=t.manager.c.get(i.xpath),o={};o.isFirstBefore=!u;var s={Controller:e,controller:n,state:o};u?r(null,s):t.manager.c.async().create(i.xpath,e).then(function(e){s.controller=e,r(null,s)}).end()})}),a.then(function(e,r){var o=e.Controller;if(i.state=e.state,l){if(3!==s.router.before.length)throw new t.Error("You should pass a callback function in arguments in case of async setting is true. before(data, Controller, callback)");n.trace("run controller before function(async). data:",i),s.router.before(i,o,function(){r(null,e)})}else n.trace("run controller before function(sync). data:",i),s.router.before(i,o),r(null,e)}),a.then(function(e,r){var s=e.controller;if(!s[i.name])throw new t.Error('"'+i.name+'" to Controller I is undefined.');l?(n.trace("run controller exec function(async). data:",i),s.show(i.name,o,function(t){if(t)throw t;r(null,e)})):(n.trace("run controller exec function(sync). data:",i),s.show(i.name,o),r(null,e))}),a.then(function(e,r){if(n.trace("run controller after function(sync). data:",i),l){if(3!==s.router.after.length)throw new t.Error("You should pass a callback function in arguments in case of async setting is true. after(data, Controller, callback)");n.trace("run controller after function(async). data:",i),s.router.after(i,e.Controller,function(t){r(t,e)})}else n.trace("run controller after function(sync). data:",i),s.router.after(i,e.Controller),r(null,e)}),u||a.then(function(e,t){n.trace("run controller first after function"),s.router.firstAfter(i,e.Controller,function(e,n){t(e,n)})}),a.end()}return i}(h))}this.setuped=!0},navigate:function(e,n){if(!this.setuped||!this.router)throw new t.Error('Initialization has not been performed even once. Please do a "setup()".');return this.router.navigate(e,n)},dispose:function(){n.trace(this.constructor.name,"dispose"),this.router&&this.router.dispose&&this.router.dispose(),delete this.router,delete this.setuped}},s=t.extend("beez.mvcr.RouterManager",function(){return this.initialize()},o),a=t.extend("beez.mvcr.Router",i.Router,{constructor:function(){a.__super__.constructor.apply(this,arguments)},initialize:function(){a.__super__.initialize.apply(this,arguments)},firstBefore:function(e,t){t&&t()},before:function(e,t,n){n&&n()},after:function(e,t,n){n&&n()},firstAfter:function(e,t,n){n&&n()},dispose:function(){n.trace(this.constructor.name,"dispose")}});return a.extend=t.extendThis,{Router:a,RouterManager:s}})}(this),function(){define("beez-mvcr/cssmanager",["require","exports","module","beez.core"],function(e){var t=e("beez.core"),n=t.getLogger("beez.mvcr.cssmanager"),r=t.vendor._,i=t.vendor.$,o=function(e){var t=document.styleSheets,n=r.find(t,function(t){var n=t.href;return n&&-1!==n.indexOf(e)});return n&&n.rules&&n.rules.length>0},s=function(e){var t=document.styleSheets,n=r.find(t,function(t){var n=t.href;return n&&-1!==n.indexOf(e)});return!!n},a=t.Bucks.extend("beez.mvcr.CSSManagerAsync",{initialize:function(e){this.manager=e,this._path="",this._intervalId=void 0,this._timeoutId=void 0,this.INTERVAL=t.config.manager&&t.config.manager.css&&t.config.manager.css.interval||50,this.TIMEOUT=t.config.manager&&t.config.manager.css&&t.config.manager.css.timeout||1e4},load:function(e){var o=this,a=this._path=e;if(e.match(/^(http|https):\/\/.+$/)||(a=this._path=this.manager.name2path(e)),!a)return this.empty();if(this.manager.isLoaded(a))return n.debug("path:",a,"already exists"),a=void 0,this.empty();var c='<link rel="stylesheet" href="'+r.escape(a)+'" ></link>';return i("head").append(c),this.then(function(e,r){o._intervalId=setInterval(function(){s(a)&&(o.abort(),n.debug("load finished. path:",a),r())},o.INTERVAL),o._timeoutId=setTimeout(function(){o.abort(),r(new t.Error("loading timed out. path:"+a))},o.TIMEOUT)})},remove:function(e){var t=this;return this.then(function(){return t.manager.remove(e)
})},abort:function(){clearTimeout(this._timeoutId),clearInterval(this._intervalId),delete this._timeoutId,delete this._intervalId,delete this.INTERVAL,delete this.TIMEOUT},dispose:function(){n.trace(this.constructor.name,"dispose"),delete this.manager,delete this._path,this.abort()}}),c=t.extend("beez.mvcr.CSSManager",function(){return this.initialize()},{initialize:function(){this._basePath="",t.config.url&&t.config.url.base&&(this._basePath=t.config.url.base,this._basePath.replace(/\/$/,""))},name2path:function(e){var t="";return t=this._basePath?0===e.indexOf("/")?this._basePath+e:this._basePath+"/"+e:e},async:function(){return new a(this)},remove:function(e){var t=i("link[rel=stylesheet]");return t.each(function(){-1!==this.href.indexOf(e)&&(n.debug("remove finished. name:",e,"path:",this.href),i(this).remove())}),this},isExists:o,isLoaded:s,dispose:function(){n.trace(this.constructor.name,"dispose"),delete this._basePath}});return{CSSManager:c,CSSManagerAsync:a}})}(this),function(){define("beez-mvcr/imagemanager",["require","exports","module","beez.core","beez.utils"],function(e){function t(e,t){t||(t={});var n=t.cacheKey||u,r=t.cacheId||Date.now(),i=n+"="+r;return-1===e.indexOf(i)&&(e+=(-1<e.indexOf("?")?"&":"?")+i),e}var n=e("beez.core"),r=(e("beez.utils"),n.vendor._),i=n.vendor.$,o=n.getLogger("beez.mvcr.imagemanager"),s="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAMAAAAoyzS7AAAABlBMVEX///8AAABVwtN+AAAAAXRSTlMAQObYZgAAAA1JREFUeNoBAgD9/wAAAAIAAVMrnDAAAAAASUVORK5CYII=",a=0,c=function(){return"__beez_manager_image_uid_"+a++},u="_",l=n.extend("beez.mvcr.ImagePool",function(e,t){return this.initialize(e,t)},{initialize:function(e,t){this.options=t||{},this.limit=e,this._total=0,this._num_used=0,this._using={},this._unused=[]},create:function(e){var t;if(e=e||{},this._unused.length>0)t=this._unused.pop();else{if(this.limit>0&&this._total>=this.limit)throw new n.Error("image pool limit exceeds!");t=new Image,t.__beez_manager_image_uid=c(),this._total++}e.crossOrigin?t.crossOrigin=e.crossOrigin:this.options.crossOrigin&&(t.crossOrigin=this.options.crossOrigin),this._num_used++,this._using[t.__beez_manager_image_uid]=t;var r=this;return t.release=function(){this.removeAttribute("crossorigin"),this.src=s,r._using&&delete r._using[this.__beez_manager_image_uid],r._unused&&r._unused.push(this),r._num_used&&r._num_used--,delete this.release},t},living:function(){return this._num_used},peak:function(){return this._total},waiting:function(){return this._unused.length},dispose:function(){o.trace(this.constructor.name,"dispose");for(var e in this._using)this._using[e].release();for(delete this._using;this._unused.length>0;){var t=this._unused.pop();delete t.__beez_manager_image_uid}delete this._unused,delete this._num_used,delete this._total,delete this._limit}}),h=n.Bucks.extend("beez.mvcr.ImageManagerAsync",{initialize:function(e){this.imageManager=e,this.cacheKey=e.cacheKey},loadOne:function(e,r){var o,s=this.imageManager.create(r),a=this,c=this.cacheKey;return r&&(c=r.cacheKey||c,o=r.cacheId),this.add(function(r,u,l){var h=i(s),d=function(){h.off(),l(null,s)},f=function(){var e=s.src;h.off(),s.release(),l(new n.Error("error on load image. src:"+e))},g=function(){var e=s.src;h.off(),s.release(),l(new n.Error("image loading aborted. src:"+e))};h.on("load",d),h.on("error",f),h.on("abort",g);var m=a.imageManager.imageUrl(e);o&&(m=t(m,{cacheKey:c,cacheId:o})),s.src=m})},load:function(e,t){if(r.isString(e))e=[e];else if(!r.isArray(e))throw new n.Error("url can be String or Array of string.");if(t=t||{},!r.isArray(t)){if(!r.isObject(t))throw new n.Error("options can be Object or Array of object.");t=[t]}var i=this,o=r.map(e,function(e,n){return function(r,o,s){new h(i.imageManager).loadOne(e,t[n]).end(function(e,t){s(e,t[0])},function(e){s(e)})}});return this.parallel(o)},dispose:function(){delete this.imageManager}}),d=n.extend("beez.mvcr.ImageManager",function(e){return this.initialize(e)},{initialize:function(e){var t=e&&e.size?e.size:0,n=e&&e.pool?e.pool:{},r=e&&e.cacheKey?e.cacheKey:u;this.pool=new l(t,n),this.cacheKey=r},imageUrl:function(e){return e.replace("${ratio}",10*n.utils.pixelRatio)},create:function(e){return this.pool.create(e)},living:function(){return this.pool.living()},peak:function(){return this.pool.peak()},waiting:function(){return this.pool.waiting()},load:function(e,t){return new h(this).load(e,t)},loadOne:function(e,t){return new h(this).loadOne(e,t)},dispose:function(){o.trace(this.constructor.name,"dispose"),this.pool.dispose(),delete this.pool,delete this.cacheKey}});return{ImageManager:d,ImageManagerAsync:h}})}(this),function(){define("beez.mvcr",["require","exports","module","beez.core","handlebars","beez-mvcr/model","beez-mvcr/modic","beez-mvcr/view","beez-mvcr/controller","beez-mvcr/router","beez-mvcr/cssmanager","beez-mvcr/imagemanager","beez-mvcr/base","backbone","beez-mvcr/model","beez-mvcr/view","beez-mvcr/controller","beez-mvcr/router","beez-mvcr/cssmanager","beez-mvcr/imagemanager"],function e(t){var n=t("beez.core"),r=n.getLogger("beez.mvcr");if(n.mvcr)return r.debug("beez.mvcr already defined."),n.mvcr;var i=t("handlebars");n.getTemplate=function(e){return i.templates[e]};var e={initialize:function(){var e=t("beez-mvcr/model"),n=t("beez-mvcr/modic"),r=t("beez-mvcr/view"),i=t("beez-mvcr/controller"),o=t("beez-mvcr/router"),s=t("beez-mvcr/cssmanager"),a=t("beez-mvcr/imagemanager"),c=t("beez-mvcr/base");this.Model=e.Model,this.ModelManager=e.ModelManager,this.ModelManagerAsync=e.ModelManagerAsync,this.Collection=e.Collection,this.Modic=n.Modic,this.View=r.View,this.ViewAsync=r.ViewAsync,this.ViewManager=r.ViewManager,this.ViewManagerAsync=r.ViewManagerAsync,this.Controller=i.Controller,this.ControllerManager=i.ControllerManager,this.ControllerManagerAsync=i.ControllerManagerAsync,this.Router=o.Router,this.RouterManager=o.RouterManager,this.CSSManager=s.CSSManager,this.CSSManagerAsync=s.CSSManagerAsync,this.ImageManager=a.ImageManager,this.ImageManagerAsync=a.ImageManagerAsync,this.ManagerBase=c.ManagerBase,this.Base=c.Base}},o=n.extend("beez.MVCR",function(){return this.initialize()},e),s=new o;n.mvcr=s,n.Model=s.Model,n.Collection=s.Collection,n.Modic=s.Modic,n.View=s.View,n.Controller=s.Controller,n.Router=s.Router;var a=t("backbone");n.history=a.history;var c=n.config.manager||{},u={initialize:function(){this.setuped=!1,this.model=void 0,this.m=void 0,this.view=void 0,this.v=void 0,this.controller=void 0,this.c=void 0,this.router=void 0,this.r=void 0,this.css=void 0,this.image=void 0},setup:function(e){if(this.setuped)return this;if(e=e||{},this.setuped=!0,e.model)this.model=e.model;else{var n=t("beez-mvcr/model");this.model=new n.ModelManager("midx")}if(this.m=this.model,e.view)this.view=e.view;else{var r=t("beez-mvcr/view");this.view=new r.ViewManager("vidx")}if(this.v=this.view,e.controller)this.controller=e.controller;else{var i=t("beez-mvcr/controller");this.controller=new i.ControllerManager}if(this.c=this.controller,e.router)this.router=e.router;else{var o=t("beez-mvcr/router");this.router=new o.RouterManager}if(this.r=this.router,e.css)this.css=e.css;else{var s=t("beez-mvcr/cssmanager");this.css=new s.CSSManager}if(e.image)this.image=e.image;else{var a=t("beez-mvcr/imagemanager");this.image=new a.ImageManager(c.image)}return this}},l=n.extend("beez.Manager",function(){return this.initialize()},u),h=new l;return s.manager=h,n.manager=s.manager,n.mvcr})}(this);